// Type definitions for ag-grid v12.0.2
// Project: http://www.ag-grid.com/
// Definitions by: Niall Crosby <https://github.com/ceolter/>
import { Column } from "../entities/column";
import { RowNode } from "../entities/rowNode";
import { RowComp } from "./rowComp";
import { GridCell } from "../entities/gridCell";
import { Component } from "../widgets/component";
export declare class CellComp extends Component {
    private context;
    private columnApi;
    private gridApi;
    private gridOptionsWrapper;
    private expressionService;
    private rowRenderer;
    private $compile;
    private templateService;
    private valueService;
    private eventService;
    private columnController;
    private columnAnimationService;
    private rangeController;
    private focusedCellController;
    private contextMenuFactory;
    private focusService;
    private cellEditorFactory;
    private cellRendererFactory;
    private popupService;
    private cellRendererService;
    private valueFormatterService;
    private stylingService;
    private columnHoverService;
    static DOM_DATA_KEY_CELL_COMP: string;
    private eGridCell;
    private eSpanWithValue;
    private eCellWrapper;
    private eParentOfValue;
    private gridCell;
    private rangeCount;
    private eParentRow;
    private column;
    private node;
    private editingCell;
    private cellEditorInPopup;
    private hideEditorPopup;
    private cellFocused;
    private scope;
    private cellEditor;
    private cellRenderer;
    private value;
    private usingWrapper;
    private rowComp;
    private firstRightPinned;
    private lastLeftPinned;
    private colsSpanning;
    private setLeftFeature;
    constructor(column: Column, node: RowNode, scope: any, renderedRow: RowComp);
    private createGridCell();
    private addIndexChangeListener();
    private onRowIndexChanged();
    getGridCell(): GridCell;
    setFocusInOnEditor(): void;
    setFocusOutOnEditor(): void;
    destroy(): void;
    private setPinnedClasses();
    getParentRow(): HTMLElement;
    setParentRow(eParentRow: HTMLElement): void;
    setupCheckboxSelection(): void;
    getColumn(): Column;
    private getValue();
    private addRangeSelectedListener();
    private onRangeSelectionChanged();
    private addHighlightListener();
    private addChangeListener();
    private animateCellWithHighlight();
    private animateCell(cssName);
    private addCellFocusedListener();
    private checkCellFocused(event?);
    private getCellWidth();
    private setWidthOnCell();
    init(): void;
    private setupColSpan();
    private checkColSpan();
    private setColsSpanning(colsSpanning);
    private addColumnHoverListener();
    private onColumnHover();
    private addDomData();
    private onEnterKeyDown();
    private onF2KeyDown();
    private onEscapeKeyDown();
    private onPopupEditorClosed();
    isEditing(): boolean;
    private onTabKeyDown(event);
    private onBackspaceOrDeleteKeyPressed(key);
    private onSpaceKeyPressed(event);
    private onNavigationKeyPressed(event, key);
    onKeyPress(event: KeyboardEvent): void;
    onKeyDown(event: KeyboardEvent): void;
    private createCellEditorParams(keyPress, charPress, cellStartedEdit);
    private createCellEditor(keyPress, charPress, cellStartedEdit);
    private stopEditingAndFocus();
    startRowOrCellEdit(keyPress?: number, charPress?: string): void;
    startEditingIfEnabled(keyPress?: number, charPress?: string, cellStartedEdit?: boolean): boolean;
    private addInCellEditor();
    private addPopupCellEditor();
    focusCell(forceBrowserFocus?: boolean): void;
    stopRowOrCellEdit(cancel?: boolean): void;
    stopEditing(cancel?: boolean): void;
    private createParamsWithValue();
    private createEvent(event);
    getRenderedRow(): RowComp;
    isSuppressNavigable(): boolean;
    isCellEditable(): boolean;
    onMouseEvent(eventName: string, mouseEvent: MouseEvent): void;
    private onMouseOut(mouseEvent);
    private onMouseOver(mouseEvent);
    private onContextMenu(mouseEvent);
    private onCellDoubleClicked(mouseEvent);
    private onMouseDown();
    private onCellClicked(mouseEvent);
    private doIeFocusHack();
    private setInlineEditingClass();
    private populateCell();
    private addStylesFromColDef();
    private addClassesFromColDef();
    private createParentOfValue();
    isVolatile(): boolean;
    attemptCellRendererRefresh(): boolean;
    private valuesAreEqual(val1, val2);
    refreshCell(params?: {
        suppressFlash?: boolean;
        newData?: boolean;
        forceRefresh?: boolean;
        volatile?: boolean;
    }): void;
    private flashCell();
    private replaceCellContent();
    private addClassesFromRules();
    private putDataIntoCell();
    private formatValue(value);
    private createRendererAndRefreshParams(valueFormatted, cellRendererParams);
    private useCellRenderer(cellRendererKey, cellRendererParams, valueFormatted);
    private addClasses();
}
